package fr.irisa.cairn.jnimap.polylib;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(PolyLibMatrix_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class PolyLibMatrix extends JNIObject  {
	
	
	/* @generated */
	protected PolyLibMatrix(long ptr) {
		/*** PROTECTED REGION ID(PolyLibMatrix_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	
	/* @generated */
	static PolyLibMatrix build(long ptr) {
		{
			return new PolyLibMatrix(ptr);
		}
	}
	
	
	
	
	/***PROTECTED REGION ID(PolyLibMatrix_userCode) ENABLED START***/
	public static PolyLibMatrix createFromLongMatrix(long[][] t) {
		PolyLibMatrix mat = PolyLibMatrix.allocate(t.length,  t[0].length);
		for (int i = 0; i < t.length; i++) {
			for (int j = 0; j < t[0].length; j++) {
				mat.setAt(i, j, t[i][j]);
			}
		}
		
		return mat;
	}
	/***PROTECTED REGION END***/

	/*************************************** 
	 *	     Struct Field Accessors        * 
	 ***************************************/
	/*************************************************************
	 *	NbRows : int
	 *************************************************************/
	public int getNbRows() {
		return PolylibNative.matrix_get_NbRows(getNativePtr(this));
	}
	/*************************************************************
	 *	NbRows : int
	 *************************************************************/
	public void setNbRows(int object) {
		PolylibNative.matrix_set_NbRows(getNativePtr(this), object);
	}
	/*************************************************************
	 * Test if TNbRows is NULL
	 *************************************************************/
	public boolean testNbRows() {
		return PolylibNative.matrix_test_NbRows(getNativePtr(this)) != 0;
	}
	/*************************************************************
	 *	NbColumns : int
	 *************************************************************/
	public int getNbColumns() {
		return PolylibNative.matrix_get_NbColumns(getNativePtr(this));
	}
	/*************************************************************
	 *	NbColumns : int
	 *************************************************************/
	public void setNbColumns(int object) {
		PolylibNative.matrix_set_NbColumns(getNativePtr(this), object);
	}
	/*************************************************************
	 * Test if TNbColumns is NULL
	 *************************************************************/
	public boolean testNbColumns() {
		return PolylibNative.matrix_test_NbColumns(getNativePtr(this)) != 0;
	}
	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * Matrix_Alloc 
	 * 
	 * @generated
	**/
	 public static PolyLibMatrix allocate(int nbrow, int nbcols) { 
		/*** PROTECTED REGION ID(static_Matrix_Alloc) DISABLED START ***/
		PolyLibMatrix res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibMatrix.build(PolylibNative.Matrix_Alloc(nbrow, nbcols));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Polyhedron2Constraints 
	 * 
	 * @generated
	**/
	 public static PolyLibMatrix buildFromConstraints(PolyLibPolyhedron Pol) { 
		/*** PROTECTED REGION ID(static_Polyhedron2Constraints) DISABLED START ***/
		PolyLibMatrix res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolyLibMatrix.build(PolylibNative.Polyhedron2Constraints(getNativePtr(Pol)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * matrix_get 
	 * 
	 * @generated
	**/
	public long getAt(int i, int j) {
		/*** PROTECTED REGION ID(matrix_get) DISABLED START ***/
		long res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = PolylibNative.matrix_get(getNativePtr(this), i, j);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * matrix_set 
	 * 
	 * @generated
	**/
	public void setAt(int i, int j, long value) {
		/*** PROTECTED REGION ID(matrix_set) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters();
			try {
				PolylibNative.matrix_set(getNativePtr(this), i, j, value);
			} finally {
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * Matrix_Free 
	 * 
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(Matrix_Free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters();
			try {
				PolylibNative.Matrix_Free(getNativePtr(this));
			} finally {
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(PolyLibMatrix_toString) DISABLED START ***/
			return PolylibPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
